-- Text Globals
TEXT_COLOR_RED = "|cFFFF0000";
TEXT_COLOR_GREEN = "|cFF008000";
TEXT_COLOR_YELLOW = "|cFFFFFF00";
TEXT_COLOR_CYAN = "|cFF00FFFF";
TEXT_COLOR_RESET = "|r";

-- Addon Variables
TRI = {};
TRI.AddonName = GetAddOnMetadata("TabardReputationInfo", "Title");
TRI.AddonVersion = GetAddOnMetadata("TabardReputationInfo", "Version");
TRI.Tabards = {
    ["5976"] = { -- Guild Tabard
        FACTION = 1168 
    },
    ["69209"] = { -- Illustrious Guild Tabard ( 50% )
        FACTION = 1168 
    },
    ["69210"] = { -- Renowned Guild Tabard ( 100% )
        FACTION = 1168 
    },
    ["63379"] = { -- Azeroth Tabards
        FACTION = 1177 
    },
    ["63378"] = {
        FACTION = 1178 
    },
    ["64882"] = {
        FACTION = 1134 
    },
    ["64884"] = {
        FACTION = 1133 
    },
    ["65904"] = {
        FACTION = 1173 
    },
    ["65908"] = {
        FACTION = 1174 
    },
    ["65909"] = {
        FACTION = 1172 
    },
    ["65905"] = {
        FACTION = 1135 
    },
    ["65906"] = {
        FACTION = 1158 
    },
    ["65907"] = {
        FACTION = 1171 
    },
    ["20132"] = {
        FACTION = 509 
    },
    ["20131"] = {
        FACTION = 510 
    },
    ["45579"] = { -- Darnassus
        FACTION = 69
    },
    ["45580"] = { -- Exodar
        FACTION = 930
    },
    ["45578"] = { -- Gnomeregan
        FACTION = 54
    },
    ["45577"] = { -- Ironforge
        FACTION = 47
    },
    ["45574"] = { -- Stormwind
        FACTION = 72
    },
    ["45582"] = { -- Darkspear
        FACTION = 530
    },
    ["45581"] = { -- Orgrimmar
        FACTION = 76
    },
    ["45585"] = { -- Silvermoon
        FACTION = 911
    },
    ["45584"] = { -- Thunder Bluff
        FACTION = 81
    },
    ["45583"] = { -- Undercity
        FACTION = 68
    },
    ["31779"] = { -- Outland Tabards
        FACTION = 932 
    },
    ["31780"] = {
        FACTION = 934 
    },
    ["31804"] = {
        FACTION = 942 
    },
    ["31776"] = {
        FACTION = 933 
    },
    ["23999"] = {
        FACTION = 946 
    },
    ["24004"] = {
        FACTION = 947 
    },
    ["31777"] = {
        FACTION = 989 
    },
    ["31774"] = {
        FACTION = 978 
    },
    ["31773"] = {
        FACTION = 941 
    },
    ["31778"] = {
        FACTION = 1011 
    },
    ["32828"] = {
        FACTION = 1038 
    },
    ["31781"] = {
        FACTION = 935 
    },
    ["32445"] = {
        FACTION = 1031 
    },
    ["31775"] = {
        FACTION = 970 
    },
    ["35221"] = {
        FACTION = 1077 
    },
    ["43154"] = { -- Northrend Tabards
        FACTION = 1106 
    },
    ["43155"] = {
        FACTION = 1098 
    },
    ["43157"] = {
        FACTION = 1090 
    },
    ["43156"] = {
        FACTION = 1091 
    },
    ["83079"] = { -- Pandaria Tabards
        FACTION = 1353 
    },
    ["83080"] = {
        FACTION = 1352 
    },
    ["89401"] = {
        FACTION = 1302 
    },
    ["89799"] = {
        FACTION = 1341 
    },
    ["89797"] = {
        FACTION = 1269 
    },
    ["95591"] = {
        FACTION = 1387 
    },
    ["89798"] = {
        FACTION = 1337 
    },
    ["89795"] = {
        FACTION = 1345 
    },
    ["89796"] = {
        FACTION = 1271 
    },
    ["89800"] = {
        FACTION = 1270 
    },
    ["95592"] = {
        FACTION = 1388 
    },
    ["89784"] = {
        FACTION = 1272 
    },
    ["119136"] = { -- Draenor Tabards
        FACTION = 1515 
    },
    ["119135"] = {
        FACTION = 1731 
    },
    ["119133"] = {
        FACTION = 1445 
    },
    ["119138"] = {
        FACTION = 1708 
    },
    ["119140"] = {
        FACTION = 1710 
    },
    ["119137"] = {
        FACTION = 1711 
    },
    ["115518"] = {
        FACTION = 1681 
    },
    ["115517"] = {
        FACTION = 1682 
    },
    ["128450"] = {
        FACTION = 1849 
    },
    ["128449"] = {
        FACTION = 1850 
    },
    ["140575"] = { -- Legion Tabards
        FACTION = 1859 
    },
    ["140577"] = {
        FACTION = 1900 
    },
    ["140578"] = {
        FACTION = 1883 
    },
    ["140579"] = {
        FACTION = 1948 
    },
    ["140580"] = {
        FACTION = 1894 
    },
    ["147205"] = {
        FACTION = 2045 
    },
    ["152399"] = {
        FACTION = 2165 
    },
    ["152669"] = {
        FACTION = 2170 
    },
    ["160540"] = { -- Battle for Azeroth Tabards
        FACTION = 2160 
    },
    ["160541"] = {
        FACTION = 2161 
    },
    ["160542"] = {
        FACTION = 2162 
    },
    ["160539"] = {
        FACTION = 2159 
    },
    ["160546"] = {
        FACTION = 2103 
    },
    ["160547"] = {
        FACTION = 2156 
    },
    ["160548"] = {
        FACTION = 2158 
    },
    ["160545"] = {
        FACTION = 2157 
    },
    ["160544"] = {
        FACTION = 2164 
    },
    ["160543"] = {
        FACTION = 2163 
    }
};

-- Chat MSG
function TRI.PrintMSG(msg)
	text = TEXT_COLOR_CYAN .. TRI.AddonName .. " > " .. TEXT_COLOR_RESET .. msg;
	DEFAULT_CHAT_FRAME:AddMessage(text);
end

-- Event Frame
TRI.eventFrame = CreateFrame("Frame", "TRI_FRAME");
TRI.eventFrame:RegisterEvent("ADDON_LOADED");
TRI.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
--TRI.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED"); -- Out of Combat ( probably using in later updates )
function TRI_EventHandler(self, event, ...)
    local arg1, arg2 = ...;
    if event == "ADDON_LOADED" and arg1 == "TabardReputationInfo" then
        TRI.PrintMSG("v" .. TRI.AddonVersion .. " loaded successfully.");
        self:UnregisterEvent("ADDON_LOADED");
    end
end
TRI.eventFrame:SetScript("OnEvent", TRI_EventHandler);

-- Set Game Tooltip
function TRI.SetGameTooltip(tooltip)
    local _, link = tooltip:GetItem();
    if not link then return end

    local itemString = string.match(link, "item[%-?%d:]+");

    if itemString then
        local _, itemID = strsplit(":", itemString);
        if itemID then
            if TRI.Tabards[itemID] then
                local itemFaction = TRI.Tabards[itemID].FACTION;
                local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(itemFaction);
                
                local factionInfo;
                if standingID ~= 8 then -- Exalted Fix
                    factionInfo = string.format("%s %s / %s (%0.2f%%)", _G["FACTION_STANDING_LABEL" .. standingID], barValue - barMin, barMax - barMin, ((barValue - barMin) / (barMax - barMin)) * 100);
                else
                    factionInfo = string.format("%s %s / %s (%0.2f%%)", _G["FACTION_STANDING_LABEL" .. standingID], barMax, barMax, (barMax / barMax) * 100);
                end
                tooltip:AddLine("\n" .. TRI.AddonName .. ":\n" .. name .. " - " .. factionInfo);
            end
        end
    end
end
GameTooltip:HookScript("OnTooltipSetItem", TRI.SetGameTooltip);